.\" Copyright (c) 1987, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	From: @(#)install.1	8.1 (Berkeley) 6/6/93
.\" $FreeBSD: src/usr.bin/xinstall/install.1,v 1.7.2.3 1999/09/05 11:33:27 peter Exp $
.\"
.Dd September 22, 1996
.Dt INSTALL 1
.Os BSD 4.2
.Sh NAME
.Nm install
.Nd install binaries
.Sh SYNOPSIS
.Nm install
.Op Fl CcDMps
.Op Fl f Ar flags
.Op Fl g Ar group
.Op Fl m Ar mode
.Op Fl o Ar owner
.Ar file1 file2
.Nm install
.Op Fl CcDMps
.Op Fl f Ar flags
.Op Fl g Ar group
.Op Fl m Ar mode
.Op Fl o Ar owner
.Ar file1
\&...
.Ar fileN directory
.Nm install
.Fl d
.Op Fl g Ar group
.Op Fl m Ar mode
.Op Fl o Ar owner
.Ar directory
\&...
.Sh DESCRIPTION
The file(s) are moved (or copied if the
.Fl c
option is specified) to the target file or directory.
If the destination is a directory, then the
.Ar file
is moved into
.Ar directory
with its original filename.
If the target file already exists, it is overwritten if permissions
allow.
.Pp
.Bl -tag -width Ds
.It Fl C
Copy the file, as if the
.Fl c
option is specified,
except if the target file already exists and the files are the same,
then don't change the modification time of the target.
.It Fl c
Copy the file.
This flag turns off the default behavior of
.Nm install
where it deletes the original file after creating the target.
.It Fl D
Print debugging information.
If
.Fl D
is specified one or more times,
then print the renaming steps for
.Fl C .
If
.Fl D
is specified two or more times,
then warn about files that aren't installed with
.Fl C .
.It Fl d
Create directories. 
Missing parent directories are created as required.
.It Fl f
Specify the target's file flags; see
.Xr chflags 1
for a list of possible flags and their meanings.
.It Fl g
Specify a group. A numeric GID is allowed.
.It Fl M
Disable all use of
.Xr mmap 2 .
.It Fl m
Specify an alternate mode.
The default mode is set to rwxr-xr-x (0755).
The specified mode may be either an octal or symbolic value; see
.Xr chmod  1
for a description of possible mode values.
.It Fl o
Specify an owner. A numeric UID is allowed.
.It Fl p
Preserve the modification time.
Copy the file, as if the
.Fl C
(Compare and copy) option is specified,
except if the target file doesn't already exist or is different,
then preserve the modification time of the file.
.It Fl s
.Nm Install
exec's the command
.Xr strip  1
to strip binaries so that install can be portable over a large
number of systems and binary types.
.El
.Pp
By default,
.Nm
preserves all file flags, with the exception of the ``nodump'' flag.
.Pp
The
.Nm
utility attempts to prevent moving a file onto itself.
.Pp
Installing
.Pa /dev/null
creates an empty file.
.Pp
Upon successful completion a value of 0 is returned.
Otherwise, a value of 1 is returned.
.Sh FILES
.Bl -tag -width INS@XXXX -compact
.It Pa INS@XXXX
If the
.Fl C
or
.Fl p
option is used, then temporary files named INS@XXXX,
where XXXX is decided by
.Xr mkstemp 3 ,
are created in the target directory.
.Sh SEE ALSO
.Xr chflags 1 ,
.Xr chgrp 1 ,
.Xr chmod 1 ,
.Xr cp 1 ,
.Xr mv 1 ,
.Xr strip 1 ,
.Xr mmap 2 ,
.Xr chown 8
.Sh HISTORY
The
.Nm
utility appeared in
.Bx 4.2 .
.Sh BUGS
Temporary files may be left in the target directory if
.Nm
exits abnormally.
.Pp
File flags cannot be set by
.Xr fchflags 2
over a NFS file system.  Other file systems do not have a concept of flags.
.Nm
will only warn when flags could not be set on a file system
that does not support them.
